﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;

namespace WPF_TileView_Hierarchy
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		private static readonly string DescriptionsText = "Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} Description of Item {0} ";
		public Window1()
		{
			InitializeComponent();
			this.tileView.ItemsSource = this.GenerateData();
		}

		private List<DataItem> GenerateData()
		{
			List<DataItem> result = new List<DataItem>();

			for (int i = 0; i < 6; i++)
			{
				DataItem item = new DataItem()
				{
					Summary = String.Format("Summary of Item {0}", i),
					Description = String.Format(DescriptionsText, i)
				};

				for (int j = 0; j < 4; j++)
				{
					DataItem subItem = new DataItem()
					{
						Summary = String.Format("Summary of Item {0}.{1}", i, j),
						Description = String.Format(DescriptionsText, String.Format("{0}.{1}", i, j))
					};

					item.Items.Add(subItem);
				}
				result.Add(item);
			}

			return result;
		}

		private void tileView_TileStateChanged(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			e.Handled = true;
			RadTileViewItem item = e.OriginalSource as RadTileViewItem;
			if (item != null)
			{
				var fluidControls = item.ChildrenOfType<RadFluidContentControl>();
				if (fluidControls.Count == 0)
				{
					return;
				}
				RadFluidContentControl fluidControl = fluidControls[0];

				switch (item.TileState)
				{
					case TileViewItemState.Maximized:
						fluidControl.State = FluidContentControlState.Large;
						break;
					case TileViewItemState.Minimized:
						fluidControl.State = FluidContentControlState.Small;
						break;
					case TileViewItemState.Restored:
						fluidControl.State = FluidContentControlState.Normal;
						break;
				}
			}
		}
	}
}
